#include "spmv.h"

double wall_timer() {
  struct timeval tim;
  gettimeofday(&tim, NULL);
  double t = tim.tv_sec + tim.tv_usec/1e6;
  return(t);
}

/*---------------------------------------------*/
void print_header() {
  if (DOUBLEPRECISION)
    printf("\nTesting SpMV, DOUBLE precision\n");
  else
    printf("\nTesting SpMV, SINGLE precision\n");
}

/*-----------------------------------------*/
double error_norm(REAL *x, REAL *y, int n) {
  int i;
  double t, normz, normx;
  normx = normz = 0.0;
  for (i=0; i<n; i++) {
    t = x[i]-y[i];
    normz += t*t;
    normx += x[i]*x[i];
  }
  return(normz/normx);
}

/*---------------------------*/
void FreeCOO(struct coo_t *coo)
{
  free(coo->ir);
  free(coo->jc);
  free(coo->val);
}

/*---------------------------*/
void FreeCSR(struct csr_t *csr)
{
  free(csr->a);
  free(csr->ia);
  free(csr->ja);
}

/*---------------------------*/
void FreeJAD(struct jad_t *jad)
{
  free(jad->ia);
  free(jad->ja);
  free(jad->a);
  free(jad->perm);
}

/*---------------------------*/
void FreeDIA(struct dia_t *dia)
{
  free(dia->diags);
  free(dia->ioff);
}

